"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var utils_1 = require("./utils");
var config_1 = require("./config");
var options = config_1.getOptions();
var moduleOptions = config_1.getModuleOptions();
/**
 * 点击 element
 * @param el
 */
function clickElement(el) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!el)
                        return [2 /*return*/];
                    return [4 /*yield*/, el.click({ clickCount: options.uiConfig.clickCount })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
/**
 * 输入框输入文本
 * @param inputEl
 * @param text
 */
function typeInput(inputEl, text) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, inputEl.type(text, { delay: options.uiConfig.typeDelay })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
/**
 *
 * @param selectorStr
 * @param page
 * @param text
 */
function typeElInput(selectorStr, page, text) {
    return __awaiter(this, void 0, void 0, function () {
        var inputEl;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, page.$(selectorStr)];
                case 1:
                    inputEl = _a.sent();
                    if (!inputEl) return [3 /*break*/, 3];
                    return [4 /*yield*/, typeInput(inputEl, text)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
/**
 * 点击 elClick
 * @param selectorStr
 * @param page
 */
function clickElButton(selectorStr, page) {
    return __awaiter(this, void 0, void 0, function () {
        var rootEl;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, page.$(selectorStr)];
                case 1:
                    rootEl = _a.sent();
                    if (!rootEl) {
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, clickElement(rootEl)];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
/**
 *
 * @param page
 * @param testId
 * @param text
 */
function typeElSelect(selectorStr, page, text) {
    return __awaiter(this, void 0, void 0, function () {
        var selectEl, inputEl;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, page.$(selectorStr)];
                case 1:
                    selectEl = _a.sent();
                    if (!selectEl)
                        return [2 /*return*/];
                    return [4 /*yield*/, selectEl.$(moduleOptions.elSelect.inputSelector)];
                case 2:
                    inputEl = _a.sent();
                    if (!inputEl)
                        return [2 /*return*/];
                    return [4 /*yield*/, typeInput(inputEl, text)];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
/**
 *
 * @param nodes
 */
function generateVisibleInfos(nodes) {
    var resultArr = [];
    nodes.forEach(function (node) {
        var nodeRect = node.getBoundingClientRect();
        var item = {
            visible: false
        };
        if (nodeRect && (nodeRect.width || nodeRect.height)) {
            item.visible = true;
        }
        resultArr.push(item);
    });
    return resultArr;
}
/**
 * 获取第一个可见的元素索引
 * @param {*} iSelectorStr
 * @param {*} page
 */
function findVisibleElIndex(iSelectorStr, page) {
    return __awaiter(this, void 0, void 0, function () {
        var selectorStr, listVisibleArr, visibleInx;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    selectorStr = iSelectorStr;
                    return [4 /*yield*/, page.$$eval(selectorStr, generateVisibleInfos)];
                case 1:
                    listVisibleArr = _a.sent();
                    visibleInx = listVisibleArr.findIndex(function (item) { return item.visible; });
                    return [2 /*return*/, visibleInx];
            }
        });
    });
}
/**
 * 获取第一个 visible 的元素
 * @param iSelectorStr
 * @param page
 */
function findVisibleEl(iSelectorStr, page) {
    return __awaiter(this, void 0, void 0, function () {
        var visibleInx, items, visibleItem;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, findVisibleElIndex(iSelectorStr, page)];
                case 1:
                    visibleInx = _a.sent();
                    return [4 /*yield*/, page.$$(iSelectorStr)];
                case 2:
                    items = _a.sent();
                    visibleItem = items[visibleInx];
                    return [2 /*return*/, visibleItem];
            }
        });
    });
}
/**
 *
 * @param page
 */
function findElDropDownItemEls(page) {
    return __awaiter(this, void 0, void 0, function () {
        var dropDownSelectorStr, visibleInx, listEls, currItem, items;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dropDownSelectorStr = moduleOptions.elSelect.dropdownListSelector;
                    return [4 /*yield*/, findVisibleElIndex(dropDownSelectorStr, page)];
                case 1:
                    visibleInx = _a.sent();
                    return [4 /*yield*/, page.$$(dropDownSelectorStr)];
                case 2:
                    listEls = _a.sent();
                    currItem = listEls[visibleInx];
                    items = currItem.$$(moduleOptions.elSelect.dorpdownItemSelector);
                    return [2 /*return*/, items];
            }
        });
    });
}
/**
 *
 * @param selectorStr
 * @param page
 * @param inx
 * @param emptySelectorStr
 */
function selectElSelectItem(selectorStr, page, inx, emptySelectorStr) {
    return __awaiter(this, void 0, void 0, function () {
        var rootEl, inputEl, items, targetItem, otherEl;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, page.$(selectorStr)];
                case 1:
                    rootEl = _a.sent();
                    if (!rootEl)
                        return [2 /*return*/];
                    return [4 /*yield*/, rootEl.$(moduleOptions.elSelect.inputSelector)];
                case 2:
                    inputEl = _a.sent();
                    if (!inputEl)
                        return [2 /*return*/];
                    return [4 /*yield*/, inputEl.focus()];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, page.waitFor(options.uiConfig.uiWaitTime)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, findElDropDownItemEls(page)];
                case 5:
                    items = _a.sent();
                    if (!(items && items.length)) return [3 /*break*/, 10];
                    targetItem = items[inx];
                    if (!targetItem) return [3 /*break*/, 10];
                    return [4 /*yield*/, targetItem.click()];
                case 6:
                    _a.sent();
                    if (!emptySelectorStr) return [3 /*break*/, 10];
                    return [4 /*yield*/, page.$(emptySelectorStr)];
                case 7:
                    otherEl = _a.sent();
                    return [4 /*yield*/, clickElement(otherEl)];
                case 8:
                    _a.sent();
                    return [4 /*yield*/, page.waitFor(options.uiConfig.uiWaitTime)];
                case 9:
                    _a.sent();
                    _a.label = 10;
                case 10: return [2 /*return*/];
            }
        });
    });
}
/**
 *
 * @param dropDownListEl
 * @param colNum
 * @param inx
 */
function selectElCascaderItem(dropDownListEl, colNum, inx) {
    return __awaiter(this, void 0, void 0, function () {
        var menus, colMenu, colMenuItems, targetItem;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, dropDownListEl.$$(moduleOptions.elCascader.dropdownColSelector)];
                case 1:
                    menus = _a.sent();
                    colMenu = menus[colNum];
                    return [4 /*yield*/, colMenu.$$(moduleOptions.elCascader.dropdownColItemSelector)];
                case 2:
                    colMenuItems = _a.sent();
                    targetItem = colMenuItems[inx];
                    return [4 /*yield*/, clickElement(targetItem)];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
/**
 *
 * @param selectotStr
 * @param page
 * @param vals
 */
function selectElCascaderItems(selectotStr, page, vals) {
    return __awaiter(this, void 0, void 0, function () {
        var rootEl, inputEl, listEl, promiseFns;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, page.$(selectotStr)];
                case 1:
                    rootEl = _a.sent();
                    if (!rootEl)
                        return [2 /*return*/];
                    return [4 /*yield*/, rootEl.$(moduleOptions.elCascader.inputSelector)];
                case 2:
                    inputEl = _a.sent();
                    return [4 /*yield*/, clickElement(inputEl)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, page.waitFor(options.uiConfig.uiWaitTime)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, findVisibleEl(moduleOptions.elCascader.dropdownListSelector, page)];
                case 5:
                    listEl = _a.sent();
                    promiseFns = vals.map(function (val, inx) {
                        return function () { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, selectElCascaderItem(listEl, inx, val)];
                                    case 1:
                                        _a.sent();
                                        return [4 /*yield*/, page.waitFor(options.uiConfig.uiWaitTime)];
                                    case 2:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); };
                    });
                    return [4 /*yield*/, utils_1.runPromises(promiseFns)];
                case 6:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
/**
 *
 * @param selectorStr
 * @param page
 * @param filePath
 */
function elUploadFiles(selectorStr, page, filePath) {
    return __awaiter(this, void 0, void 0, function () {
        var rootEl, inputEl;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, page.$(selectorStr)];
                case 1:
                    rootEl = _a.sent();
                    if (!rootEl)
                        return [2 /*return*/];
                    return [4 /*yield*/, rootEl.$(moduleOptions.elUpload.inputSelector)];
                case 2:
                    inputEl = _a.sent();
                    if (!inputEl) return [3 /*break*/, 4];
                    return [4 /*yield*/, inputEl.uploadFile.apply(inputEl, filePath)];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4: return [2 /*return*/];
            }
        });
    });
}
/**
 *
 * @param selectorStr
 * @param page
 * @param inxs
 */
function checkElCheckboxGroup(selectorStr, page, inxs) {
    return __awaiter(this, void 0, void 0, function () {
        var rootEl, inputEls, promiseFns;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, page.$(selectorStr)];
                case 1:
                    rootEl = _a.sent();
                    if (!rootEl)
                        return [2 /*return*/];
                    return [4 /*yield*/, rootEl.$$(moduleOptions.elCheckboxGroup.labelSelector)];
                case 2:
                    inputEls = _a.sent();
                    promiseFns = inputEls.map(function (inputItem, inx) {
                        return function () { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!inxs.includes(inx)) return [3 /*break*/, 2];
                                        return [4 /*yield*/, clickElement(inputItem)];
                                    case 1:
                                        _a.sent();
                                        _a.label = 2;
                                    case 2: return [2 /*return*/];
                                }
                            });
                        }); };
                    });
                    return [4 /*yield*/, utils_1.runPromises(promiseFns)];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports["default"] = {
    clickElement: clickElement,
    typeInput: typeInput,
    runPromises: utils_1.runPromises,
    clickElButton: clickElButton,
    typeElInput: typeElInput,
    typeElSelect: typeElSelect,
    selectElCascaderItems: selectElCascaderItems,
    checkElCheckboxGroup: checkElCheckboxGroup,
    elUploadFiles: elUploadFiles,
    selectElSelectItem: selectElSelectItem
};
