const moduleOptions = {
  elSelect: {
    inputSelector: '.el-input__inner',
    dropdownListSelector: ".el-select-dropdown__list",
    dorpdownItemSelector: ".el-select-dropdown__item"
  },
  elCascader: {
    inputSelector: ".el-input__inner",
    dropdownListSelector: ".el-cascader__dropdown",
    dropdownColSelector: '.el-cascader-menu',
    dropdownColItemSelector: ".el-cascader-node"
  },
  elUpload: {
    inputSelector: ".el-upload__input"
  },
  elCheckboxGroup: {
    labelSelector: ".el-checkbox__label"
  }
};

type Config = {
  clickCount?: number,
  typeDelay?: number,
  uiWaitTime?: number,
  apiWaitTime?: number
}

const options = {
  uiConfig: {
    clickCount: 1,
    typeDelay: 30,
    uiWaitTime: 500,
    apiWaitTime: 1500
  }
};

export function setUIOptions(config: Config) {
  options.uiConfig = Object.assign(options.uiConfig, config || {});
}

export function getOptions() {
  return options;
}

export function getModuleOptions() {
  return moduleOptions;
}