/**
 * 串行运行 promises 数组
 * @param promises 
 */
export async function runPromises(promises: Array<Function | Promise<unknown>>): Promise<unknown> {
  return new Promise((resolve, reject) => {

    function run(promises: Array<Function | Promise<unknown>>, inx: number = 0) {
      if (inx > promises.length - 1) {
        resolve();
        return;
      }
      let currPromise: any = promises[inx];
      if (typeof currPromise === 'function') {
        currPromise = currPromise();
      }
      if (currPromise && currPromise.then) {
        currPromise.then(() => {
          run(promises, inx + 1);
        }).catch((err: any) => {
          reject(err);
        })
      } else {
        run(promises, inx + 1);
      }
    }

    run(promises);
  })
}

